diff -uwr sourceold/scripts/mdbdef.cpp source/scripts/mdbdef.cpp
--- sourceold/scripts/mdbdef.cpp	2011-10-11 23:05:47.966796800 +0800
+++ source/scripts/mdbdef.cpp	2012-04-24 13:23:39.488281200 +0800
@@ -76,7 +76,7 @@
 		{
 			ActionParamsStruct params;
 			params.Set_Basic(this,100,1);
-			if (AdjustInf && Is_Soldier(enemy))
+			if (AdjustInf && enemy->As_SoldierGameObj())
 			{
 				params.Set_Attack(Commands->Get_Bone_Position(enemy,"c R Foot"),MaxDis,0.0,true);
 				params.AttackCheckBlocked = true;
@@ -170,7 +170,7 @@
 	}
 	if (!Is_VTOL(enemy) && State == 3)
 	{
-		SmartGameObj* obj1 = (SmartGameObj*)As_SmartGameObj(enemy);
+		SmartGameObj* obj1 = enemy->As_SmartGameObj();
 		if(!obj1 
 		|| !obj1->Is_Stealthed() 
 		|| Commands->Get_Distance(Commands->Get_Position(obj), Commands->Get_Position(enemy)) <= Get_Float_Parameter("MaxStealthAttackDistance"))
@@ -179,7 +179,7 @@
 			{
 				ActionParamsStruct params;
 				params.Set_Basic(this,100,1);
-				if (AdjustInf && Is_Soldier(enemy))
+				if (AdjustInf && enemy->As_SoldierGameObj())
 				{
 					params.Set_Attack(Commands->Get_Bone_Position(enemy,"c R Foot"),MaxDis,0.0,true);
 					params.AttackCheckBlocked = true;
@@ -393,7 +393,7 @@
 		{
 			ActionParamsStruct params;
 			params.Set_Basic(this,100,1);
-			if (AdjustInf && Is_Soldier(enemy))
+			if (AdjustInf && enemy->As_SoldierGameObj())
 			{
 				params.Set_Attack(Commands->Get_Bone_Position(enemy,"c R Foot"),MaxDis,0.0,true);
 				params.AttackCheckBlocked = true;
@@ -514,7 +514,7 @@
 	}
 	ActionParamsStruct params;
 	params.Set_Basic(this,100,1);
-	if (AdjustInf && Is_Soldier(enemy))
+	if (AdjustInf && enemy->As_SoldierGameObj())
 	{
 		params.Set_Attack(Commands->Get_Bone_Position(enemy,"c R Foot"),MaxDis,0.0,true);
 		params.AttackCheckBlocked = true;
@@ -612,7 +612,7 @@
 	{
 		ActionParamsStruct params;
 		params.Set_Basic(this,100,1);
-		if (AdjustInf && Is_Soldier(enemy))
+		if (AdjustInf && enemy->As_SoldierGameObj())
 		{
 			params.Set_Attack(Commands->Get_Bone_Position(enemy,"c R Foot"),MaxDis,0.0,true);
 			params.AttackCheckBlocked = true;
diff -uwr sourceold/scripts/mdbevf.cpp source/scripts/mdbevf.cpp
--- sourceold/scripts/mdbevf.cpp	2011-10-11 23:05:46.441406200 +0800
+++ source/scripts/mdbevf.cpp	2012-04-24 13:23:55.576171800 +0800
@@ -1046,7 +1046,7 @@
 }
 void ExpVehFacClass::Object_Hook(void *,GameObject *obj)
 {
-	if (Is_Vehicle(obj))
+	if (obj->As_VehicleGameObj())
 	{
 		int Team = Get_Object_Type(obj);
 		if (ExpVehFac[Team] && ExpVehFac[Team]->Loaded)
diff -uwr sourceold/scripts/neo.cpp source/scripts/neo.cpp
--- sourceold/scripts/neo.cpp	2011-10-11 23:05:42.591796800 +0800
+++ source/scripts/neo.cpp	2012-04-24 13:25:21.594726500 +0800
@@ -15,6 +15,7 @@
 #include "engine.h"
 #include "neo.h"
 #include "VehicleGameObjDef.h"
+#include "SoldierGameObj.h"
 
 //**************Script Functions*****************
 
@@ -432,13 +433,13 @@
 						else
 						{
 							//new is a player(in tank),old is not
-							if (Is_Soldier(old))
+							if (old->As_SoldierGameObj())
 							{
 								//old is a soldier
 								//switch to new target,old not worth it
 								selected = target;
 							}
-							else if (Is_Vehicle(old))
+							else if (old->As_VehicleGameObj())
 							{
 								//old is a vehicle,new is a player in tank
 								//switch based on distance
@@ -473,13 +474,13 @@
 						else
 						{
 							//new is a player on foot,old is not a player
-							if (Is_Soldier(old))
+							if (old->As_SoldierGameObj())
 							{
 								//old is a soldier
 								//switch to new target,old not worth it
 								selected = target;
 							}
-							else if (Is_Vehicle(old))
+							else if (old->As_VehicleGameObj())
 							{
 								//old is a vehicle
 								//switch if old out of range and new is close
@@ -501,13 +502,13 @@
 					if (vehicle) //is the old in a vehicle?
 					{
 						//old in vehicle
-						if (Is_Soldier(target))
+						if (target->As_SoldierGameObj())
 						{
 							//new is a soldier,old is player in a tank
 							//Perhaps an out of range check here?
 							selected = 0; //keep old					
 						}
-						else if (Is_Vehicle(target))
+						else if (target->As_VehicleGameObj())
 						{
 							//new is a vehicle,old is player in a tank
 							//switch if new closer
@@ -516,12 +517,12 @@
 					}
 					else //old on foot
 					{
-						if (Is_Soldier(target))
+						if (target->As_SoldierGameObj())
 						{
 							//new is a soldier
 							selected = Get_Closest(obj,target,old);
 						}
-						else if (Is_Vehicle(target))
+						else if (target->As_VehicleGameObj())
 						{
 							//new is a vehicle,old just a player
 							selected = target;
@@ -619,7 +620,7 @@
 
 	if (target)//Just to be on the safe side
 	{
-		if (Is_Soldier(target)) //is the target a soldier?
+		if (target->As_SoldierGameObj()) //is the target a soldier?
 		{
 			if (Get_Int_Parameter("vsSoldier")) 
 				return true; //Use Primary
@@ -627,7 +628,7 @@
 				return false; //Use Secondary
 		}
 
-		if (Is_Vehicle(target))
+		if (target->As_VehicleGameObj())
 		{
 			if (Get_Vehicle_Mode(target) != VEHICLE_TYPE_FLYING)
 			{
diff -uwr sourceold/scripts/renalert.cpp source/scripts/renalert.cpp
--- sourceold/scripts/renalert.cpp	2012-02-13 19:12:33.152742200 +0800
+++ source/scripts/renalert.cpp	2012-04-25 12:11:13.884765600 +0800
@@ -256,12 +256,13 @@
 	*/
 	if (AP_mine) //Is this mine anti-personnel?
 	{
-		if (Is_Soldier(enemy))//using newer, more specific code
+		if (enemy->As_SoldierGameObj())//using newer, more specific code
 		{
 			GameObject *damager = Get_GameObj(ownerID);
 			int objID = Commands->Get_Player_Type(obj);
 			int ownerID = Commands->Get_Player_Type(damager);
 			Commands->Set_Player_Type(obj, 2); //Change teams to avoid friendly fire
+			SetExplosionObj(obj);
 			if (objID != ownerID) //Did the owner switch teams?
 			{
 				Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"),0); //Die Infidel!
@@ -270,17 +271,19 @@
 			{
 				Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"),damager); //Die Infidel!
 			}
+			SetExplosionObj(0);
 			return; //the mine is dead, end now
 		}
 	}
 	if (AT_mine) //Is this mine anti-tank?
 	{
-		if (Is_Vehicle(enemy))//using newer, more specific code
+		if (enemy->As_VehicleGameObj())//using newer, more specific code
 		{
 			GameObject *damager = Get_GameObj(ownerID);
 			int objID = Commands->Get_Player_Type(obj);
 			int ownerID = Commands->Get_Player_Type(damager);
 			Commands->Set_Player_Type(obj, 2); //Change teams to avoid friendly fire
+			SetExplosionObj(obj);
 			if (objID != ownerID) //Did the owner switch teams?
 			{
 				Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"), 0); //Good-bye cruel world!
@@ -289,6 +292,7 @@
 			{
 				Commands->Apply_Damage(obj,Get_Float_Parameter("Trigger_Damage"),Get_Parameter("Trigger_Warhead"), damager); //Good-bye cruel world!
 			}
+			SetExplosionObj(0);
 			return; //the mine is dead, end now
 		}
 	}
@@ -1474,11 +1478,11 @@
 	switch(toggle)
 	{
 	case 0: //Case 0 prioritizes vehicles over infantry
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			return target; //new target is a vehicle
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			return old; //old target is a vehicle
 		}
@@ -1488,7 +1492,7 @@
 		}
 		break;//just to be safe
 	case 1: //Case 1 prioritizes infantry over vehicles
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			if (Get_Vehicle(old))// Did the old target get in a vehicle?
 			{
@@ -1499,7 +1503,7 @@
 				return old; //old soldier
 			}
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			if (Get_Vehicle(target))// Did the new target get in a vehicle? 
 			{
@@ -1684,7 +1688,7 @@
 {
 	if (Get_Int_Parameter("AdjustAim"))
 	{
-		if (Is_Soldier(target))
+		if (target->As_SoldierGameObj())
 		{
 			return true;
 		}
@@ -2006,11 +2010,11 @@
 	switch(toggle)
 	{
 	case 0: //Case 0 prioritizes vehicles over infantry
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			return target; //new target is a vehicle
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			return old; //old target is a vehicle
 		}
@@ -2020,7 +2024,7 @@
 		}
 		break;//just to be safe
 	case 1: //Case 1 prioritizes infantry over vehicles
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			if (Get_Vehicle(old))// Did the old target get in a vehicle?
 			{
@@ -2031,7 +2035,7 @@
 				return old; //old soldier
 			}
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			if (Get_Vehicle(target))// Did the new target get in a vehicle? 
 			{
@@ -2216,7 +2220,7 @@
 {
 	if (Get_Int_Parameter("AdjustAim"))
 	{
-		if (Is_Soldier(target))
+		if (target->As_SoldierGameObj())
 		{
 			return true;
 		}
@@ -2553,11 +2557,11 @@
 	switch(toggle)
 	{
 	case 0: //Case 0 prioritizes vehicles over infantry
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			return target; //new target is a vehicle
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			return old; //old target is a vehicle
 		}
@@ -2567,7 +2571,7 @@
 		}
 		break;//just to be safe
 	case 1: //Case 1 prioritizes infantry over vehicles
-		if (Is_Soldier(old) && !(Is_Soldier(target)))
+		if (old->As_SoldierGameObj() && !(target->As_SoldierGameObj()))
 		{
 			if (Get_Vehicle(old))// Did the old target get in a vehicle?
 			{
@@ -2578,7 +2582,7 @@
 				return old; //old soldier
 			}
 		}
-		else if (!(Is_Soldier(old)) && Is_Soldier(target))
+		else if (!(old->As_SoldierGameObj()) && target->As_SoldierGameObj())
 		{
 			if (Get_Vehicle(target))// Did the new target get in a vehicle? 
 			{
@@ -2763,7 +2767,7 @@
 {
 	if (Get_Int_Parameter("AdjustAim"))
 	{
-		if (Is_Soldier(target))
+		if (target->As_SoldierGameObj())
 		{
 			return true;
 		}
@@ -3000,7 +3004,7 @@
 			msg.Format("%s dumped some Ore at the refinary, giving the %s %d additional credits each.", str, str2, (int)value);
 			delete[] str2;
 			delete[] str;
-			SSGMGameLog::Log_Message(msg,"_ORE");
+			SSGMGameLog::Log_Message(msg,"_OREDUMP");
 			msg.Format("ppage %d Well done soldier, you have given your team mates an extra %d credits each", PlayerID, (int)value);
 			Console_Input(msg);
 			Commands->Give_Points(driver, reward, false);
@@ -3133,7 +3137,7 @@
 			msg.Format("%s dumped some Ore at the refinary, giving the %s %d additional credits each.", str, str2, (int)value);
 			delete[] str2;
 			delete[] str;
-			SSGMGameLog::Log_Message(msg,"_ORE");
+			SSGMGameLog::Log_Message(msg,"_OREDUMP");
 			msg.Format("ppage %d Well done soldier, you have given your team mates an extra %d credits each", PlayerID, (int)value);
 			Console_Input(msg);
 			Commands->Give_Points(driver, reward, false);
@@ -3820,8 +3824,11 @@
 {
 	Vector3 pos;
 	pos = Commands->Get_Position(obj);
-	int testID;
+	int testID = 0;
+	if (killer)
+	{
 	testID = Commands->Get_ID(killer);
+	}
 	const char *explosion = Get_Parameter("Explosion");
 	const char *warhead = Get_Parameter("Warhead");
 	float damage = Get_Float_Parameter("DamageStrength");
@@ -3916,8 +3923,10 @@
 			const char *warhead = Get_Parameter("Warhead");
 			float range = Get_Float_Parameter("DamageRadius");
 			//Time to break a few windows
+			SetExplosionObj(obj);
 			Ranged_Percentage_Damage_To_Buildings(Epercentage, warhead, Commands->Get_Position(obj), range, Get_GameObj(ownerID));
 			Ranged_Variable_Percent_Vehicle_Damage(Epercentage, Fpercentage, FF, warhead, Commands->Get_Position(obj), range, Get_GameObj(ownerID)); 
+			SetExplosionObj(0);
 		}
 		//Kill MAD Tank 
 		//'0' Damager used so owner won't get points for tank itself
diff -uwr sourceold/scripts/scripts.cpp source/scripts/scripts.cpp
--- sourceold/scripts/scripts.cpp	2011-10-11 23:06:22.983398400 +0800
+++ source/scripts/scripts.cpp	2012-05-10 21:50:14.808593700 +0800
@@ -315,7 +315,7 @@
 	FILE *f = fopen(path,"at");
 	if (f)
 	{
-		fprintf(f,"Critical Scripts.dll error,parameter is %s\n",parameterName);
+		fprintf(f,"Critical error the name is %s parameter is %s the map is %s\n",this->Get_Name(),parameterName,The_Game()->Get_Map_Name());
 		fclose(f);
 	}
 	return -1;
diff -uwr sourceold/scripts/scripts.h source/scripts/scripts.h
--- sourceold/scripts/scripts.h	2011-10-11 21:44:21.639648400 +0800
+++ source/scripts/scripts.h	2012-05-13 21:46:14.438320300 +0800
@@ -142,19 +142,117 @@
 	void	Auto_Save_Variable( void * data_ptr, int data_size, int id );
 	virtual ~ScriptImpClass();
 	const char* Get_Name(void);
-	void Created(GameObject *obj) {} //triggers on script creation
-	void Destroyed(GameObject *obj) {} //triggers on script shutdown
-	void Killed(GameObject *obj,GameObject *killer) {} //triggers when the object script is attached to dies
-	void Damaged(GameObject *obj,GameObject *damager,float amount) {} //triggers when the object script is attached to is damaged. The damager is always the gunner,not the vechicle.
-	void Custom(GameObject *obj,int type,int param,GameObject *sender) {} //triggers when the script is sent a custom (aka message). Several system events are triggered by Customs as well,see the #defines below
-	void Sound_Heard(GameObject *obj,const CombatSound & sound) {} //something to do with sound,I think it triggers when the object the script is attached to hears a sound)
-	void Enemy_Seen(GameObject *obj,GameObject *enemy) {} //triggers when the object script is attached to spots an enemy
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason) {} //triggers when an action on the object the script is attached to completes
-	void Timer_Expired(GameObject *obj,int number) {} //triggers when a timer goes off
-	void Animation_Complete(GameObject *obj,const char *animation_name) {} //triggers when an animation on the object the script is attached to completes
-	void Poked(GameObject *obj,GameObject *poker) {} //triggers when the object that this scripts is attached to is poked (i.e. player pushes the action key while this object is active),this doesnt work in MP unless you have tt.dll
-	void Entered(GameObject *obj,GameObject *entererererer) {} //triggers when the zone this script is attached to is entered
-	void Exited(GameObject *obj,GameObject *exiterererer) {} //triggers when the zone this script is attached to is exited
+
+  /*! Script event that is triggered when this script is created
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  */
+  void Created(GameObject *obj) {}
+
+  /*! Script event that is triggered when the object gets destroyed. Note that when a player changes
+  * character this event does *not* get triggered, if you need to react to this scenario overload
+  * Detach() instead
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  */
+  void Destroyed(GameObject *obj) {}
+
+  /*! Script event that is triggered when the object is killed. Note that this event will not be
+  * triggered if the object is destroyed without being killed via loss of health, such as by another
+  * script calling ScriptCommands::Destroy_Object()
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] killer Pointer to the GameObject that killed our object. NULL for environment damage
+  */
+  void Killed(GameObject *obj,GameObject *killer) {}
+
+  /*! Script event that is triggered when the object takes damage
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] damager
+  *    Pointer to the GameObject that damaged our object, which will be the shooter and not the
+  *    vehicle they are driving (if any). NULL for environment damage
+  * \param[in] amount The amount of damage that was done to the object
+  */
+  void Damaged(GameObject *obj,GameObject *damager,float amount) {}
+  
+  /*! Script event that is triggered when the object recieves a custom, which could have been sent
+  * by another script or be triggered by a system event.
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] type The type of custom that has been recieved
+  * \param[in] param The parameter that was attached to the custom by the sender
+  * \param[in] sender Pointer to the GameObject from which this custom was sent
+  */
+  void Custom(GameObject *obj,int type,int param,GameObject *sender) {}
+
+  /*! Script event that is triggered when the object hears a sound. Not currently well understood.
+  * Presumably requires innate AI to be enabled and for the object to have a listener scale of >0
+  * defined in it's preset definition.
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] sound Information about the sound that has been heard
+  */
+  void Sound_Heard(GameObject *obj,const CombatSound & sound) {}
+
+  /*! Script event that is triggered when the object sees an enemy. This requires innate AI to be
+  * enabled and for the object to have a sight range of >0 defined in its preset definition.
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] enemy Pointer to the enemy GameObject that was seen by the object
+  */
+  void Enemy_Seen(GameObject *obj,GameObject *enemy) {}
+
+  /*! Script event that is triggered when the object completes an action that this script is
+  * defined as the observer for.
+  *
+  * \see ActionParamsStruct
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] action_id ID of the action that was completed
+  * \param[in] complete_reason The reason the action was marked as complete
+  */
+  void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason) {}
+
+  /*! Script event that is triggered when a script defined timer expires
+  *
+  * \see ScriptCommands::Start_Timer()
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] number IF of the timer that expired
+  */
+  void Timer_Expired(GameObject *obj,int number) {}
+
+
+  /*! Script event that is triggered when the object completes an animation
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] animation_name Name of the animation that was completed
+  */
+  void Animation_Complete(GameObject *obj,const char *animation_name) {}
+
+  /*! Script event that is triggered when the object has been poked by a player. Requires tt.dll
+  * to work correctly in multiplayer mode.
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] poker Pointer to the GameObject of the player that poked this object
+  */
+  void Poked(GameObject *obj,GameObject *poker) {}
+
+  /*! Script event that is triggered on a script zone when an object enters its defined area
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] enterer Pointer to the GameObject of the object that entered this zone
+  */
+  void Entered(GameObject *obj,GameObject *enterer) {}
+  
+  /*! Script event that is triggered on a script zone when an object leaves its defined area
+  *
+  * \param[in] obj Pointer to the GameObject this script is attached to
+  * \param[in] exiter Pointer to the GameObject of the object that left this zone
+  */
+  void Exited(GameObject *obj,GameObject *exiter) {}
+
 	GameObject* Owner()
 	{
 		return mOwner;
@@ -230,29 +328,36 @@
 	void Join_Conversation( int active_conversation_id )	{ ActiveConversationID = active_conversation_id; }
 	void Start_Conversation( const char * name )			{ ConversationName = name; }
 	void Dock_Vehicle( const Vector3 &dock_location, const Vector3 &dock_entrance ) { DockLocation = dock_location; DockEntrance = dock_entrance; }
+
+  /*! Priority for this action, this determines if it will override an existing action on the target
+  * object. If the priority of the existing action is lower, or there is no existing action, this
+  * action will be executed. If the priority is lower than that of the existing action it will be
+  * ignored. */
 	int Priority;
-	int ActionID;
-	long ObserverID;
+  int ActionID;                 //!< An identifier for this action, passed to ScriptImpClass::Action_Complete
+  long ObserverID;              //!< UID of a script to recieve notifications about this action, such as ScriptImpClass::Action_Complete
 	Vector3 LookLocation;
 	GameObject *LookObject;
 	float LookDuration;
-	Vector3 MoveLocation;
+  Vector3 MoveLocation;         //!< A target location for this object to attempt to reach
 	GameObject *MoveObject;
 	Vector3 MoveObjectOffset;
 	float MoveSpeed;
-	float MoveArrivedDistance;
-	bool MoveBackup;
+  float MoveArrivedDistance;    //!< How close to the target location the object must get to be considered as arrived
+  bool MoveBackup;              //!< True to drive in reverse, false to drive forwards
 	bool MoveFollow;
 	bool MoveCrouched;
+  /*! True to use the global pathfind data to assist in route planning, false to ignore it
+  * (presumably only useful if you specify a waypath to follow) */
 	bool MovePathfind;
-	bool ShutdownEngineOnArrival;
-	float AttackRange;
-	float AttackError;
+  bool ShutdownEngineOnArrival; //!< True to shutdown engine sounds upon arrival, false to leave them enabled
+  float AttackRange;            //!< The maximum range at which the object should attack an enemy
+  float AttackError;            //!< Apply up to this much error to the turret aim. If this is 0 the aim will be perfect
 	bool AttackErrorOverride;
-	GameObject *AttackObject;
+  GameObject *AttackObject;     //!< An object to track the movement of and fire at (if within range)
 	bool AttackPrimaryFire;
 	bool AttackCrouched;
-	Vector3 AttackLocation;
+  Vector3 AttackLocation;       //!< A location to fire at, presumably ignored if AttackObject is not NULL
 	bool AttackCheckBlocked;
 	bool AttackActive;
 	bool AttackWanderAllowed;
@@ -343,25 +448,26 @@
 
 enum {
 	CUSTOM_EVENT_SYSTEM_FIRST = 1000000000,
-	CUSTOM_EVENT_SOUND_ENDED, //sent when sound has ended
-	CUSTOM_EVENT_BUILDING_POWER_CHANGED, //sent when building power changes
-	CUSTOM_EVENT_DOCK_BACKING_IN, //sent when vehicle arrives at dock
-	CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT, //sent to set cinematic slot
-	CUSTOM_EVENT_CINEMATIC_SET_LAST_SLOT = CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT + 20, //sent to set cinematic slot
-	CUSTOM_EVENT_POWERUP_GRANTED, //sent when powerup is granted
-	CUSTOM_EVENT_BUILDING_DAMAGED, //sent when building is damaged
-	CUSTOM_EVENT_BUILDING_REPAIRED, //sent when building is repaired
-	CUSTOM_EVENT_VEHICLE_ENTERED, //sent when vehicle is entered
-	CUSTOM_EVENT_VEHICLE_EXITED, //sent when vehicle is exited
-	CUSTOM_EVENT_ATTACK_ARRIVED, //sent on attack arrived
-	CUSTOM_EVENT_CONVERSATION_BEGAN, //sent on conversation begin
-	CUSTOM_EVENT_CONVERSATION_REMARK_STARTED, //sent on conversation remark started
-	CUSTOM_EVENT_CONVERSATION_REMARK_ENDED, //sent on conversation remark ended
-	CUSTOM_EVENT_LADDER_OCCUPIED, //sent on ladder occupied
-	CUSTOM_EVENT_FALLING_DAMAGE, //sent on falling damage
-	CUSTOM_EVENT_VEHICLE_OWNER, //Special custom one sent by the new ownership code in tt.dll and by the scripts in mdbevf.cpp
-	CUSTOM_EVENT_VEHICLE_DRIVER, //Special custom one sent to vehicles where the driver/owner gets out to trigger it to find out its driver
-	CUSTOM_EVENT_VHEICLE_DRIVER_ID, //Response to CUSTOM_EVENT_VEHICLE_DRIVER, passes the owner GameObjects ID as the param
+	CUSTOM_EVENT_SOUND_ENDED,                                                           //!< Sent when sound has ended
+	CUSTOM_EVENT_BUILDING_POWER_CHANGED,                                                //!< Sent when building power changes
+	CUSTOM_EVENT_DOCK_BACKING_IN,                                                       //!< Sent when vehicle arrives at dock
+	CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT = 10000,                                      //!< Sent to set cinematic slot
+	CUSTOM_EVENT_CINEMATIC_SET_LAST_SLOT = CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT + 39,  //!< Sent to set cinematic slot
+	CUSTOM_EVENT_POWERUP_GRANTED = 1000000025,                                          //!< Sent when powerup is granted
+	CUSTOM_EVENT_BUILDING_DAMAGED,                                                      //!< Sent when building is damaged
+	CUSTOM_EVENT_BUILDING_REPAIRED,                                                     //!< Sent when building is repaired
+	CUSTOM_EVENT_VEHICLE_ENTERED,                                                       //!< Sent when vehicle is entered
+	CUSTOM_EVENT_VEHICLE_EXITED,                                                        //!< Sent when vehicle is exited
+	CUSTOM_EVENT_ATTACK_ARRIVED,                                                        //!< Sent on attack arrived
+	CUSTOM_EVENT_CONVERSATION_BEGAN,                                                    //!< Sent on conversation begin
+	CUSTOM_EVENT_CONVERSATION_REMARK_STARTED,                                           //!< Sent on conversation remark started
+	CUSTOM_EVENT_CONVERSATION_REMARK_ENDED,                                             //!< Sent on conversation remark ended
+	CUSTOM_EVENT_LADDER_OCCUPIED,                                                       //!< Sent on ladder occupied
+	CUSTOM_EVENT_FALLING_DAMAGE,                                                        //!< Sent on falling damage
+	CUSTOM_EVENT_VEHICLE_OWNER,                                                         //!< Special custom one sent by the new ownership code in tt.dll and by the scripts in mdbevf.cpp
+	CUSTOM_EVENT_VEHICLE_DRIVER,                                                        //!< Special custom one sent to vehicles where the driver/owner gets out to trigger it to find out its driver
+	CUSTOM_EVENT_VHEICLE_DRIVER_ID,                                                     //!< Response to CUSTOM_EVENT_VEHICLE_DRIVER, passes the owner GameObjects ID as the param
+	CUSTOM_EVENT_BEACON_DEPLOYED,                                                       //!< Sent when a beacon is deployed
 };
 
 enum {
@@ -478,6 +584,34 @@
 	int	( * Get_Random_Int )( int min, int max ); 
 	GameObject * ( * Find_Random_Simple_Object )( const char *preset_name );
 	void	( * Set_Model )( GameObject * obj, const char * model_name );
+
+  /*!
+  * Plays an animation upon the target game object, or a sub-object of that game object
+  *
+  * \param obj
+  *   Game object upon which to play the animation, this must be a PhysicalGameObj
+  * \param anim_name
+  *   Name of the animation to play upon the game object, in the form model.animation
+  * \param looping
+  *   Set to true to make the entire animation play repeatedly in an infinite loop from start to
+  *   end. Cannot be used in conjunction with the start_frame and end_frame parameters
+  * \param sub_obj_name
+  *   Not really sure what this is for... to be documented later :)
+  * \param start_frame
+  *   First frame number from the animation to be played
+  * \param end_frame
+  *   Last frame number from the animation to be played
+  * \param is_blended
+  *   Set to true to blend the animation with the current bone positions of the game object, this
+  *   only works on instances of SoldierGameObj.
+  *
+  * \note
+  *   Whilst this function does not allow you to create a looping animation from a subset of the
+  *   frames within the overall animation you can still do this by restarting the animation when
+  *   ScriptImpClass::Animation_Complete() is called. Alternatively you could use the new
+  *   LoopedAnimationController class to handle this for you, leaving your script code free of
+  *   the extra logic required to implement this functionality.
+  */
 	void	( * Set_Animation )( GameObject * obj, const char * anim_name, bool looping, const char * sub_obj_name, float start_frame, float end_frame, bool is_blended);
 	void	( * Set_Animation_Frame )( GameObject * obj, const char * anim_name, int frame );
 	int	( * Create_Sound )( const char * sound_preset_name, const Vector3 & position, GameObject * creator );
